# This is a -*- Tcl -*- library script and belongs to the
# `Jumble Library for Tcl and Friends'.
#
# flow.tcl --- New control structures
#
# Copyright (C) 1997, 1998 Stefan Hornburg
#
# Author: Stefan Hornburg <racke@gundel.han.de>
# Maintainer: Stefan Hornburg <racke@gundel.han.de>
# Version: 0.0.3
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
# 
# This file is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this file; see the file COPYING.  If not, write to the Free
# Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package require Error
package require Sequence

# ---------------------------------------------------------------
# PROC: juf_branch VALUE [PATTERN SCRIPT] ...
#
# Creates and evaluates `switch' statement.
# Causes error if VALUE matches to none of the PATTERN arguments.
# Add `default {}' to the arguments to override this.
# ---------------------------------------------------------------

proc juf_branch {value args} {
	array set opts $args
	if [info exists opts(default)] {
		set default_action $opts(default)
		unset opts(default)
	} else {
		set default_action "Juf::Error::fault badoption [list $value] [list [array names opts]]"
	}
	uplevel switch -- [list $value] [array get opts] \
			default [list $default_action]
}

package provide juf::flow 0.0.1
package provide Flow 0.0.3

# SOME SETTINGS FOR GOOD OLD EMACS:
# Local Variables:
# tcl-default-application: "tclsh"
# End: