# This is a -*- Tcl -*- library script and belongs to the
# `Jumble Library for Tcl and Friends'.
#
# libtool.tcl --- functions for Tcl shared libraries
#
# Copyright (C) 1998 Stefan Hornburg
#
# Author: Stefan Hornburg <racke@gundel.han.de>
# Maintainer: Stefan Hornburg <racke@gundel.han.de>
# Version: 0.0.3
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
# 
# This file is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this file; see the file COPYING.  If not, write to the Free
# Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

namespace eval Juf {namespace eval Libtool {}}

# ---------------------------------------------------------------------
# PROC: packagelist LIB
#
# Generates list with the packages a shared library LIB provides.
# Each element is a list with the package name and the package version.
# ---------------------------------------------------------------------

proc Juf::Libtool::packagelist {lib} {
	# create slave interpreter
	set interp [interp create]
	# pass library name to slave interpreter
	$interp eval set lib [list $lib]
	# determine packages
	$interp eval {
		foreach pkg [package names] {
			package forget $pkg
		}
		load $lib
		set pkglist ""
		if [llength [package names]] {
			foreach pkg [package names] {
				lappend pkglist [list $pkg [package provide $pkg]]
			}
		}
		set pkglist
	}
}

package provide Libtool 0.0.3

# SOME SETTINGS FOR GOOD OLD EMACS:
# Local Variables:
# tcl-default-application: "tclsh"
# End: