# This is a -*- Tcl -*- library script and belongs to the
# `Jumble Library for Tcl and Friends'.
#
# lol.tcl --- Functions for manipulating lists of lists
#
# Copyright (C) 1998 Stefan Hornburg
#
# Author: Stefan Hornburg <racke@gundel.han.de>
# Maintainer: Stefan Hornburg <racke@gundel.han.de>
# Version: 0.0.4
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
# 
# This file is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this file; see the file COPYING.  If not, write to the Free
# Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package require Sequence
namespace eval Juf {namespace eval LOL {}}

# -----------------------------------------
# FUNCTION: insert LOL LIST VALUE
#
# Inserts VALUE into LOL according to LIST.
# -----------------------------------------

proc Juf::LOL::insert {lol list value} {
	upvar $lol mylist
	array set myhash $mylist

	if [llength $list] {
		set key [Juf::Sequence::shift list]
		if ![info exists myhash($key)] {
			set myhash($key) ""
		}
		insert myhash($key) $list $value
	} else {
		lappend myhash() $value
	}

	set mylist [array get myhash]
}

package provide LOL 0.0.4

